#include <stdio.h>
#include <math.h>
#include "winbgi2.h"
#define N 200

int spline(double x[],double y[],int n1,double a[],double b[],double c[],double d[]);
void trid(double a[],double b[],double c[],double d[],int n);
double spl_int(double x[],double a[],double b[],double c[],double d[],int n,double xx);

//  program do cwiczenia interpolacji
void main()
{
	double x[200],y[200],a[200],b[200],c[200],d[200],blad[200];	// tablice ze wspczynnikami i dane wejciowe
	double xp,xk,dx,xx,yy,x1,y1,x2,y2;							// zmienne
	int i,j,n1,n;

//  deklaracje plikowe
	FILE *plik1=fopen("dane.dat","r");
	FILE *plik2=fopen("wynik.dat","w");
	
//  wczytanie wezlow funkcji interpolowanej
	fscanf(plik1,"%d",&n1);
	printf("n=%d\n",n1);
	for(i=1;i<=n1;i++)
	{ 
		fscanf(plik1,"%lf%lf",&x[i],&y[i]);
		printf("%lf  %lf\n",x[i],y[i]);
	}

//  wczytanie przedzialu i kroku interpolacji	
	printf("podaj xp,xk,dx=");
	scanf("%lf%lf%lf",&xp,&xk,&dx);

//  interpolacja          n - ilosc splinow n=n1-1

	n=spline(x,y,n1,a,b,c,d);

//  grafika

//  wyznaczenie wspolczynnikow spline'a
//      y(x) = a(i)*t^3 + b(i)*t^2 + c(i)*t^1 + d(i)  ; t = x - x(i)

	graphics(600,600);
	scale(-10., 0., 10., 10.);
	title("x","y","y(x)");
	for(i = 1 ; i<=n ;i++)
		circle(x[i],y[i],3);

	wait();

// koczenie pracy z plikiem
	fclose(plik1);
	fclose(plik2);
}

//  wyznaczanie wspolczynnikow splinow a,b,c,d
int spline(double x[],double y[],int n1,double a[],double b[],double c[],double d[])
{
	int i,n;
	double aa[200],bb[200],cc[200],dd[200];
	double ll,lp;

//  ilosc segmentow spline'a    
	n=n1-1;

//  rownanie dla brzegu lewego (warunek naturalny)

	ll = x[2]-x[1];
    bb[1] = 2*ll;
    cc[1] =   ll;
    dd[1] = 3*(y[2]-y[1]);

//  rownania dla punktow wewnetrznych
	for(i=2;i<=n;i++)
	{
         ll    = x[i]-x[i-1];
         lp    = x[i+1]-x[i];
         aa[i] = lp;
         bb[i] = 2*(ll+lp);
         cc[i] = ll;
         dd[i] = 3*ll/lp*(y[i+1]-y[i]) + 3*lp/ll*(y[i]-y[i-1]);
	}
//  rownanie dla brzegu prawego (warunek naturalny)
    ll     = x[n1]-x[n];
	aa[n1] =   ll;
    bb[n1] = 2*ll;
    dd[n1] = 3*(y[n1]-y[n]);

//  wyznaczenie pochodnych (nachylen), 
//  rozwiazanie trojdiagonalnego ukladu rownan

      trid (aa,bb,cc,dd, n1);

//  wyznaczenie wspolczynnikow spline'a
//      y(x) = a(i)*t^3 + b(i)*t^2 + c(i)*t^1 + d(i)  ; t = x - x(i)

	for(i=1;i<=n1;i++)
	{
         d[i] = y[i];
         c[i] = dd[i];
	}
	for(i=1;i<=n;i++)
	{
         ll   = x[i+1]-x[i];
         b[i] = ( 3/ll*(d[i+1]-d[i]) - (c[i+1]+2*c[i]) )/ll;
         a[i] = ( 2/ll*(d[i]-d[i+1]) + (c[i+1]+  c[i]) )/ll/ll;
	}
	return n;
}

// rozwiazywanie ukladu r-n z macierza trojdiagonalna
void trid(double a[],double b[],double c[],double d[],int n)
{
	int i;
	double q;
	for(i=2;i<=n;i++)
	{
		q    = a[i]/b[i-1];
        b[i] = b[i] - q*c[i-1];
        d[i] = d[i] - q*d[i-1];
	}

    d[n] = d[n]/b[n];
	for(i=n-1;i>=1;i=i-1) 
		d[i] = (d[i] - c[i]*d[i+1])/b[i];
}

// funkcja obliczajaca wartosc funkcji interpolowanej
double spl_int(double x[],double a[],double b[],double c[],double d[],int n,double xx)
{
	int i,ii;
	double yy,t;
	// okreslenie przedzialu na ktorym lezy punkt ( i -->  x(i) < x < x(i+1) )
	for (i=2;i<=n+1;i++)
	{
		ii = i-1;
		if(xx<=x[i]) break;
	}
	// wyznaczenie y
	// y(x) = a(i)*t^3 + b(i)*t^2 + c(i)*t^1 + d(i)  ; t = x - x(i)

    t  = xx-x[ii];
    yy = d[ii] + t*(c[ii] + t*(b[ii] + t*a[ii]));
	return yy;
}
